package sun.tools.serialver;

import java.applet.Applet;
import java.awt.Button;
import java.awt.Container;
import java.awt.Event;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Label;
import java.awt.TextField;
import java.awt.Window;
import java.io.BufferedInputStream;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.ObjectStreamClass;
import java.text.MessageFormat;
import java.util.Properties;

public class SerialVer extends Applet {
   // $FF: renamed from: gb java.awt.GridBagLayout
   GridBagLayout field_0;
   TextField classname_t;
   Button show_b;
   TextField serialversion_t;
   Label footer_l;

   public synchronized void init() {
      String var1 = System.getProperty("java.home");
      String var2 = System.getProperty("rmi.home");
      if (var2 == null || var2.length() == 0) {
         var2 = var1;
      }

      pushPropFile(var2, "serialver.properties");
      this.field_0 = new GridBagLayout();
      ((Container)this).setLayout(this.field_0);
      GridBagConstraints var3 = new GridBagConstraints();
      var3.fill = 1;
      Label var4 = new Label(I18N("FullClassName"));
      var4.setAlignment(2);
      this.field_0.setConstraints(var4, var3);
      ((Container)this).add(var4);
      this.classname_t = new TextField(20);
      var3.gridwidth = -1;
      var3.weightx = (double)1.0F;
      this.field_0.setConstraints(this.classname_t, var3);
      ((Container)this).add(this.classname_t);
      this.show_b = new Button(I18N("Show"));
      var3.gridwidth = 0;
      var3.weightx = (double)0.0F;
      this.field_0.setConstraints(this.show_b, var3);
      ((Container)this).add(this.show_b);
      Label var5 = new Label(I18N("SerialVersion"));
      var5.setAlignment(2);
      var3.gridwidth = 1;
      this.field_0.setConstraints(var5, var3);
      ((Container)this).add(var5);
      this.serialversion_t = new TextField(50);
      this.serialversion_t.setEditable(false);
      var3.gridwidth = 0;
      this.field_0.setConstraints(this.serialversion_t, var3);
      ((Container)this).add(this.serialversion_t);
      this.footer_l = new Label();
      var3.gridwidth = 0;
      this.field_0.setConstraints(this.footer_l, var3);
      ((Container)this).add(this.footer_l);
      this.classname_t.requestFocus();
   }

   public void start() {
      this.classname_t.requestFocus();
   }

   public boolean action(Event var1, Object var2) {
      if (var1.target == this.classname_t) {
         this.show((String)var1.arg);
         return true;
      } else if (var1.target == this.show_b) {
         this.show(this.classname_t.getText());
         return true;
      } else {
         return false;
      }
   }

   public boolean handleEvent(Event var1) {
      boolean var2 = super.handleEvent(var1);
      return var2;
   }

   void show(String var1) {
      try {
         this.footer_l.setText("");
         this.serialversion_t.setText("");
         if (!var1.equals("")) {
            String var2 = serialSyntax(var1);
            if (var2 != null) {
               this.serialversion_t.setText(var2);
            } else {
               this.footer_l.setText(I18N("NotSerializable", var1));
            }
         }
      } catch (ClassNotFoundException var3) {
         this.footer_l.setText(I18N("ClassNotFound", var1));
      }
   }

   static String serialSyntax(String var0) throws ClassNotFoundException {
      Class var1 = Class.forName(var0);
      ObjectStreamClass var2 = ObjectStreamClass.lookup(var1);
      return var2 != null ? "    static final long serialVersionUID = " + var2.getSerialVersionUID() + "L;" : null;
   }

   public static String I18N(String var0) {
      return System.getProperty(var0, "<" + var0 + ">");
   }

   public static String I18N(String var0, String var1) {
      return I18N(var0, var1, (String)null);
   }

   public static String I18N(String var0, String var1, String var2) {
      String var3 = System.getProperty(var0);
      if (var3 == null) {
         return "Message '" + var0 + "' not found";
      } else {
         Object[] var4 = new Object[]{var1, var2};

         for(int var5 = 0; var5 < var4.length; ++var5) {
            if (var4[var5] != null & !(var4[var5] instanceof String)) {
               var4[var5] = var4[var5].toString();
            }
         }

         return MessageFormat.format(var3, var4);
      }
   }

   static void pushPropFile(String var0, String var1) {
      String var2 = var0 + System.getProperty("file.separator") + "lib" + System.getProperty("file.separator") + var1;

      try {
         Properties var3 = new Properties(System.getProperties());
         BufferedInputStream var4 = new BufferedInputStream(new FileInputStream(var2));
         var3.load(var4);
         ((InputStream)var4).close();
         System.setProperties(var3);
      } catch (IOException var5) {
         System.err.println("failed to read properties file: " + var2);
      }
   }

   public static void main(String[] var0) {
      String var1 = System.getProperty("java.home");
      String var2 = System.getProperty("rmi.home");
      if (var2 == null || var2.length() == 0) {
         var2 = var1;
      }

      pushPropFile(var2, "serialver.properties");
      boolean var3 = false;

      int var4;
      for(var4 = 0; var4 < var0.length; ++var4) {
         if (var0[var4].equals("-show")) {
            var3 = true;
         } else {
            if (!var0[var4].startsWith("-")) {
               break;
            }

            System.err.println(I18N("invalid.flag", var0[var4]));
            usage();
            System.exit(1);
         }
      }

      if (!var3) {
         if (var4 == var0.length) {
            usage();
            System.exit(0);
         }

         for(int var8 = var4; var8 < var0.length; ++var8) {
            try {
               String var9 = serialSyntax(var0[var8]);
               if (var9 != null) {
                  System.out.println(var0[var8] + ":" + var9);
               } else {
                  System.err.println(I18N("NotSerializable", var0[var8]));
               }
            } catch (ClassNotFoundException var7) {
               System.err.println(I18N("ClassNotFound", var0[var8]));
            }
         }

      } else {
         if (var4 < var0.length) {
            System.err.println(I18N("ignoring.classes"));
            System.exit(1);
         }

         SerialVerFrame var5 = new SerialVerFrame();
         SerialVer var6 = new SerialVer();
         var6.init();
         ((Container)var5).add("Center", var6);
         ((Window)var5).pack();
         ((Window)var5).show();
      }
   }

   public static void usage() {
      System.err.println(I18N("usage"));
   }
}
